#include <stdio.h>
#include <stdlib.h>
#include <math.h>

int     stack = 2;
int     blocks_per_stack = 6;

void
usage()
{
    printf( "Usage: gen_block stack blocks_per_stack\n" );
    exit( 0 );
}

int
main( argc, argv )
    int         argc;
    char        **argv;
{
    int         i, j, a, b;
    int         next_block;
    int         blocks[128];

    if( argc <= 2 ) {
    	usage();
    }

    stack = atoi( argv[1] );
    blocks_per_stack = atoi( argv[2] );

    printf( "Parameters:\n" );
    printf( "\tname: bw-large-f\n" );
    printf( "\tblocks: %d\n", stack*blocks_per_stack );

    printf( "Initial:\n" );

    next_block = 0;
    for( i = 1; i <= stack; i++ ) {
        for( j = 1; j <= blocks_per_stack; j++ ) {
            next_block++;
            if( j == 1) {
                printf( "\tABOVE, %d, CLEAR\n", next_block );
                printf( "\tBELOW, %d, BLOCK, %d\n", next_block, next_block+1 );
            }
            else
            if( j == blocks_per_stack ) {
                printf( "\tABOVE, %d, BLOCK, %d\n", next_block, next_block-1 );
                printf( "\tBELOW, %d, TABLE\n", next_block );
            }
            else {
                printf( "\tABOVE, %d, BLOCK, %d\n", next_block, next_block-1 );
                printf( "\tBELOW, %d, BLOCK, %d\n", next_block, next_block+1 );
            }
        }
    }

    printf( "Goal:\n" );

    next_block = 0;
    for( i = 1; i <= stack; i++ ) {
        for( j = 1; j <= blocks_per_stack; j++ ) {
            next_block++;
            blocks[j] = next_block;
        }
        for( j = 1; j <= blocks_per_stack; j++ ) {
            a = j + rand()%(blocks_per_stack-j+1);
            b = blocks[a];
            blocks[a] = blocks[j];
            blocks[j] = b;
        }

        for( j = 1; j <= blocks_per_stack; j++ ) {
            if( j == 1) {
                printf( "\tABOVE, %d, CLEAR\n", blocks[j] );
                printf( "\tBELOW, %d, BLOCK, %d\n", blocks[j], blocks[j+1] );
            }
            else
            if( j == blocks_per_stack ) {
                printf( "\tABOVE, %d, BLOCK, %d\n", blocks[j], blocks[j-1] );
                printf( "\tBELOW, %d, TABLE\n", blocks[j] );
            }
            else {
                printf( "\tABOVE, %d, BLOCK, %d\n", blocks[j], blocks[j-1] );
                printf( "\tBELOW, %d, BLOCK, %d\n", blocks[j], blocks[j+1] );
            }
        }
    }

}
